Index: NEMO/branches/2019/dev_r11078_OSMOSIS_IMMERSE_Nurser/src/OCE/ZDF/zdfosm.F90
===================================================================
--- NEMO/branches/2019/dev_r11078_OSMOSIS_IMMERSE_Nurser/src/OCE/ZDF/zdfosm.F90	(revision 12384)
+++ NEMO/branches/2019/dev_r11078_OSMOSIS_IMMERSE_Nurser/src/OCE/ZDF/zdfosm.F90	(revision 12928)
@@ -1123,29 +1063,21 @@
        ! GN 25/8: need to change tmask --> wmask
 
-     DO jk = 2, jpkm1
-         DO jj = 2, jpjm1
-             DO ji = 2, jpim1
-                p_avt(ji,jj,jk) = MAX( zdiffut(ji,jj,jk), avtb(jk) ) * tmask(ji,jj,jk)
-                p_avm(ji,jj,jk) = MAX( zviscos(ji,jj,jk), avmb(jk) ) * tmask(ji,jj,jk)
-             END DO
-         END DO
-     END DO
+     DO_3D_00_00( 2, jpkm1 )
+          p_avt(ji,jj,jk) = MAX( zdiffut(ji,jj,jk), avtb(jk) ) * tmask(ji,jj,jk)
+          p_avm(ji,jj,jk) = MAX( zviscos(ji,jj,jk), avmb(jk) ) * tmask(ji,jj,jk)
+     END_3D
       ! Lateral boundary conditions on ghamu and ghamv, currently on W-grid  (sign unchanged), needed to caclulate gham[uv] on u and v grids
      CALL lbc_lnk_multi( 'zdfosm', p_avt, 'W', 1. , p_avm, 'W', 1.,   &
       &                  ghamu, 'W', 1. , ghamv, 'W', 1. )
-       DO jk = 2, jpkm1
-           DO jj = 2, jpjm1
-               DO ji = 2, jpim1
-                  ghamu(ji,jj,jk) = ( ghamu(ji,jj,jk) + ghamu(ji+1,jj,jk) ) &
-                     &  / MAX( 1., tmask(ji,jj,jk) + tmask (ji + 1,jj,jk) ) * umask(ji,jj,jk)
-
-                  ghamv(ji,jj,jk) = ( ghamv(ji,jj,jk) + ghamv(ji,jj+1,jk) ) &
-                      &  / MAX( 1., tmask(ji,jj,jk) + tmask (ji,jj+1,jk) ) * vmask(ji,jj,jk)
-
-                  ghamt(ji,jj,jk) =  ghamt(ji,jj,jk) * tmask(ji,jj,jk)
-                  ghams(ji,jj,jk) =  ghams(ji,jj,jk) * tmask(ji,jj,jk)
-               END DO
-           END DO
-        END DO
+       DO_3D_00_00( 2, jpkm1 )
+            ghamu(ji,jj,jk) = ( ghamu(ji,jj,jk) + ghamu(ji+1,jj,jk) ) &
+               &  / MAX( 1., tmask(ji,jj,jk) + tmask (ji + 1,jj,jk) ) * umask(ji,jj,jk)
+
+            ghamv(ji,jj,jk) = ( ghamv(ji,jj,jk) + ghamv(ji,jj+1,jk) ) &
+                &  / MAX( 1., tmask(ji,jj,jk) + tmask (ji,jj+1,jk) ) * vmask(ji,jj,jk)
+
+            ghamt(ji,jj,jk) =  ghamt(ji,jj,jk) * tmask(ji,jj,jk)
+            ghams(ji,jj,jk) =  ghams(ji,jj,jk) * tmask(ji,jj,jk)
+       END_3D
         ! Lateral boundary conditions on final outputs for hbl,  on T-grid (sign unchanged)
         CALL lbc_lnk_multi( 'zdfosm', hbl, 'T', 1., dh, 'T', 1., hmle, 'T', 1. )
@@ -1161,5 +1093,5 @@
             IF ( iom_use("us_x") ) CALL iom_put( "us_x", tmask(:,:,1)*zustke*zcos_wind )   ! x surface Stokes drift
             IF ( iom_use("us_y") ) CALL iom_put( "us_y", tmask(:,:,1)*zustke*zsin_wind )  ! y surface Stokes drift
-            IF ( iom_use("wind_wave_abs_power") ) CALL iom_put( "wind_wave_abs_power", 1000.*rau0*tmask(:,:,1)*zustar**2*zustke )
+            IF ( iom_use("wind_wave_abs_power") ) CALL iom_put( "wind_wave_abs_power", 1000.*rho0*tmask(:,:,1)*zustar**2*zustke )
          ! Stokes drift read in from sbcwave  (=2).
          CASE(2)
@@ -1171,5 +1103,5 @@
             IF ( iom_use("hsw_NP") ) CALL iom_put( "hsw_NP", (0.22/grav)*wndm**2*tmask(:,:,1) )                   ! significant wave height from NP spectrum
             IF ( iom_use("wndm") ) CALL iom_put( "wndm", wndm*tmask(:,:,1) )                   ! U_10
-            IF ( iom_use("wind_wave_abs_power") ) CALL iom_put( "wind_wave_abs_power", 1000.*rau0*tmask(:,:,1)*zustar**2* &
+            IF ( iom_use("wind_wave_abs_power") ) CALL iom_put( "wind_wave_abs_power", 1000.*rho0*tmask(:,:,1)*zustar**2* &
                  & SQRT(ut0sd**2 + vt0sd**2 ) )
          END SELECT
@@ -1196,6 +1128,6 @@
          IF ( iom_use("zvstr") ) CALL iom_put( "zvstr", tmask(:,:,1)*zvstr )         ! mixed velocity scale
          IF ( iom_use("zla") ) CALL iom_put( "zla", tmask(:,:,1)*zla )         ! langmuir #
-         IF ( iom_use("wind_power") ) CALL iom_put( "wind_power", 1000.*rau0*tmask(:,:,1)*zustar**3 ) ! BL depth internal to zdf_osm routine
-         IF ( iom_use("wind_wave_power") ) CALL iom_put( "wind_wave_power", 1000.*rau0*tmask(:,:,1)*zustar**2*zustke )
+         IF ( iom_use("wind_power") ) CALL iom_put( "wind_power", 1000.*rho0*tmask(:,:,1)*zustar**3 ) ! BL depth internal to zdf_osm routine
+         IF ( iom_use("wind_wave_power") ) CALL iom_put( "wind_wave_power", 1000.*rho0*tmask(:,:,1)*zustar**2*zustke )
          IF ( iom_use("zhbl") ) CALL iom_put( "zhbl", tmask(:,:,1)*zhbl )               ! BL depth internal to zdf_osm routine
          IF ( iom_use("zhml") ) CALL iom_put( "zhml", tmask(:,:,1)*zhml )               ! ML depth internal to zdf_osm routine
@@ -1229,5 +1161,5 @@
 
    ! Alan: do we need zb?
-   SUBROUTINE zdf_osm_vertical_average( jnlev_av, zt, zs, zu, zv, zdt, zds, zdb, zdu, zdv )
+   SUBROUTINE zdf_osm_vertical_average( jnlev_av, zt, zs, zu, zv, zdt, zds, zdb, zdu, zdv, Kmm, Kbb )
      !!---------------------------------------------------------------------
      !!                   ***  ROUTINE zdf_vertical_average  ***
@@ -1240,5 +1172,6 @@
      !!----------------------------------------------------------------------
 
-        INTEGER, DIMENSION(jpi,jpj) :: jnlev_av  ! Number of levels to average over.
+       INTEGER, INTENT(in) ::   Kmm, Kbb          ! time-level indices
+        INTEGER, DIMENSION(jpi,jpj) :: jnlev_av   ! Number of levels to average over.
 
         ! Alan: do we need zb?
@@ -1256,35 +1189,33 @@
         zu   = 0._wp
         zv   = 0._wp
-        DO jj = 2, jpjm1                                 !  Vertical slab
-         DO ji = 2, jpim1
-            zthermal = rab_n(ji,jj,1,jp_tem) !ideally use ibld not 1??
-            zbeta    = rab_n(ji,jj,1,jp_sal)
-               ! average over depth of boundary layer
-            zthick = epsln
-            DO jk = 2, jnlev_av(ji,jj)
-               zthick = zthick + e3t_n(ji,jj,jk)
-               zt(ji,jj)   = zt(ji,jj)  + e3t_n(ji,jj,jk) * tsn(ji,jj,jk,jp_tem)
-               zs(ji,jj)   = zs(ji,jj)  + e3t_n(ji,jj,jk) * tsn(ji,jj,jk,jp_sal)
-               zu(ji,jj)   = zu(ji,jj)  + e3t_n(ji,jj,jk) &
-                     &            * ( ub(ji,jj,jk) + ub(ji - 1,jj,jk) ) &
-                     &            / MAX( 1. , umask(ji,jj,jk) + umask(ji - 1,jj,jk) )
-               zv(ji,jj)   = zv(ji,jj)  + e3t_n(ji,jj,jk) &
-                     &            * ( vb(ji,jj,jk) + vb(ji,jj - 1,jk) ) &
-                     &            / MAX( 1. , vmask(ji,jj,jk) + vmask(ji,jj - 1,jk) )
-            END DO
-            zt(ji,jj) = zt(ji,jj) / zthick
-            zs(ji,jj) = zs(ji,jj) / zthick
-            zu(ji,jj) = zu(ji,jj) / zthick
-            zv(ji,jj) = zv(ji,jj) / zthick
-            ! Alan: do we need zb?
-            zdt(ji,jj) = zt(ji,jj) - tsn(ji,jj,ibld(ji,jj)+ibld_ext,jp_tem)
-            zds(ji,jj) = zs(ji,jj) - tsn(ji,jj,ibld(ji,jj)+ibld_ext,jp_sal)
-            zdu(ji,jj) = zu(ji,jj) - ( ub(ji,jj,ibld(ji,jj)+ibld_ext) + ub(ji-1,jj,ibld(ji,jj)+ibld_ext ) ) &
-                     &    / MAX(1. , umask(ji,jj,ibld(ji,jj)+ibld_ext ) + umask(ji-1,jj,ibld(ji,jj)+ibld_ext ) )
-            zdv(ji,jj) = zv(ji,jj) - ( vb(ji,jj,ibld(ji,jj)+ibld_ext) + vb(ji,jj-1,ibld(ji,jj)+ibld_ext ) ) &
-                     &   / MAX(1. , vmask(ji,jj,ibld(ji,jj)+ibld_ext ) + vmask(ji,jj-1,ibld(ji,jj)+ibld_ext ) )
-            zdb(ji,jj) = grav * zthermal * zdt(ji,jj) - grav * zbeta * zds(ji,jj)
+        DO_2D_00_00
+         zthermal = rab_n(ji,jj,1,jp_tem) !ideally use ibld not 1??
+         zbeta    = rab_n(ji,jj,1,jp_sal)
+            ! average over depth of boundary layer
+         zthick = epsln
+         DO jk = 2, jnlev_av(ji,jj)
+            zthick = zthick + e3t(ji,jj,jk, Kmm )
+            zt(ji,jj)   = zt(ji,jj)  + e3t(ji,jj,jk, Kmm ) * ts(ji,jj,jk,jp_tem, Kmm )
+            zs(ji,jj)   = zs(ji,jj)  + e3t(ji,jj,jk, Kmm ) * ts(ji,jj,jk,jp_sal, Kmm )
+            zu(ji,jj)   = zu(ji,jj)  + e3t(ji,jj,jk, Kmm ) &
+                  &            * ( uu(ji,jj,jk, Kbb ) + uu(ji - 1,jj,jk, Kbb ) ) &
+                  &            / MAX( 1. , umask(ji,jj,jk) + umask(ji - 1,jj,jk) )
+            zv(ji,jj)   = zv(ji,jj)  + e3t(ji,jj,jk, Kmm ) &
+                  &            * ( vv(ji,jj,jk, Kbb ) + vv(ji,jj - 1,jk, Kbb ) ) &
+                  &            / MAX( 1. , vmask(ji,jj,jk) + vmask(ji,jj - 1,jk) )
          END DO
-        END DO
+         zt(ji,jj) = zt(ji,jj) / zthick
+         zs(ji,jj) = zs(ji,jj) / zthick
+         zu(ji,jj) = zu(ji,jj) / zthick
+         zv(ji,jj) = zv(ji,jj) / zthick
+         ! Alan: do we need zb?
+         zdt(ji,jj) = zt(ji,jj) - ts(ji,jj,ibld(ji,jj)+ibld_ext,jp_tem, Kmm )
+         zds(ji,jj) = zs(ji,jj) - ts(ji,jj,ibld(ji,jj)+ibld_ext,jp_sal, Kmm )
+         zdu(ji,jj) = zu(ji,jj) - ( uu(ji,jj,ibld(ji,jj)+ibld_ext, Kbb ) + uu(ji-1,jj,ibld(ji,jj)+ibld_ext, Kbb ) ) &
+                  &    / MAX(1. , umask(ji,jj,ibld(ji,jj)+ibld_ext ) + umask(ji-1,jj,ibld(ji,jj)+ibld_ext ) )
+         zdv(ji,jj) = zv(ji,jj) - ( vv(ji,jj,ibld(ji,jj)+ibld_ext, Kbb ) + vv(ji,jj-1,ibld(ji,jj)+ibld_ext, Kbb ) ) &
+                  &   / MAX(1. , vmask(ji,jj,ibld(ji,jj)+ibld_ext ) + vmask(ji,jj-1,ibld(ji,jj)+ibld_ext ) )
+         zdb(ji,jj) = grav * zthermal * zdt(ji,jj) - grav * zbeta * zds(ji,jj)
+      END_2D
    END SUBROUTINE zdf_osm_vertical_average
 
@@ -1306,17 +1237,15 @@
         REAL(wp) :: ztemp
 
-        DO jj = 2, jpjm1
-           DO ji = 2, jpim1
-              ztemp = zu(ji,jj)
-              zu(ji,jj) = zu(ji,jj) * zcos_w(ji,jj) + zv(ji,jj) * zsin_w(ji,jj)
-              zv(ji,jj) = zv(ji,jj) * zcos_w(ji,jj) - ztemp * zsin_w(ji,jj)
-              ztemp = zdu(ji,jj)
-              zdu(ji,jj) = zdu(ji,jj) * zcos_w(ji,jj) + zdv(ji,jj) * zsin_w(ji,jj)
-              zdv(ji,jj) = zdv(ji,jj) * zsin_w(ji,jj) - ztemp * zsin_w(ji,jj)
-           END DO
-        END DO
+        DO_2D_00_00
+           ztemp = zu(ji,jj)
+           zu(ji,jj) = zu(ji,jj) * zcos_w(ji,jj) + zv(ji,jj) * zsin_w(ji,jj)
+           zv(ji,jj) = zv(ji,jj) * zcos_w(ji,jj) - ztemp * zsin_w(ji,jj)
+           ztemp = zdu(ji,jj)
+           zdu(ji,jj) = zdu(ji,jj) * zcos_w(ji,jj) + zdv(ji,jj) * zsin_w(ji,jj)
+           zdv(ji,jj) = zdv(ji,jj) * zsin_w(ji,jj) - ztemp * zsin_w(ji,jj)
+        END_2D
     END SUBROUTINE zdf_osm_velocity_rotation
 
-    SUBROUTINE zdf_osm_external_gradients( zdtdz, zdsdz, zdbdz )
+    SUBROUTINE zdf_osm_external_gradients( zdtdz, zdsdz, zdbdz, Kmm )
      !!---------------------------------------------------------------------
      !!                   ***  ROUTINE zdf_osm_external_gradients  ***
@@ -1328,4 +1257,5 @@
      !!----------------------------------------------------------------------
 
+       INTEGER, INTENT(in) ::   Kmm                  ! time-level index
      REAL(wp), DIMENSION(jpi,jpj) :: zdtdz, zdsdz, zdbdz   ! External gradients of temperature, salinity and buoyancy.
 
@@ -1334,23 +1264,22 @@
 
 
-     DO jj = 2, jpjm1
-        DO ji = 2, jpim1
-           IF ( ibld(ji,jj) + ibld_ext < mbkt(ji,jj) ) THEN
-              zthermal = rab_n(ji,jj,1,jp_tem) !ideally use ibld not 1??
-              zbeta    = rab_n(ji,jj,1,jp_sal)
-              jkb = ibld(ji,jj) + ibld_ext
-              jkb1 = MIN(jkb + 1, mbkt(ji,jj))
-              zdtdz(ji,jj) = - ( tsn(ji,jj,jkb1,jp_tem) - tsn(ji,jj,jkb,jp_tem ) ) &
-                   &   / e3t_n(ji,jj,ibld(ji,jj))
-              zdsdz(ji,jj) = - ( tsn(ji,jj,jkb1,jp_sal) - tsn(ji,jj,jkb,jp_sal ) ) &
-                   &   / e3t_n(ji,jj,ibld(ji,jj))
-              zdbdz(ji,jj) = grav * zthermal * zdtdz(ji,jj) - grav * zbeta * zdsdz(ji,jj)
-           END IF
-        END DO
-     END DO
+     DO_2D_00_00
+        IF ( ibld(ji,jj) + ibld_ext < mbkt(ji,jj) ) THEN
+           zthermal = rab_n(ji,jj,1,jp_tem) !ideally use ibld not 1??
+           zbeta    = rab_n(ji,jj,1,jp_sal)
+           jkb = ibld(ji,jj) + ibld_ext
+           jkb1 = MIN(jkb + 1, mbkt(ji,jj))
+           zdtdz(ji,jj) = - ( ts(ji,jj,jkb1,jp_tem, Kmm ) - ts(ji,jj,jkb,jp_tem, Kmm ) ) &
+                &   / e3t(ji,jj,ibld(ji,jj), Kmm )
+           zdsdz(ji,jj) = - ( ts(ji,jj,jkb1,jp_sal, Kmm ) - ts(ji,jj,jkb,jp_sal, Kmm ) ) &
+                &   / e3t(ji,jj,ibld(ji,jj), Kmm )
+           zdbdz(ji,jj) = grav * zthermal * zdtdz(ji,jj) - grav * zbeta * zdsdz(ji,jj)
+        END IF
+     END_2D
     END SUBROUTINE zdf_osm_external_gradients
 
-    SUBROUTINE zdf_osm_pycnocline_scalar_profiles( zdtdz, zdsdz, zdbdz )
-
+    SUBROUTINE zdf_osm_pycnocline_scalar_profiles( zdtdz, zdsdz, zdbdz, Kmm )
+
+       INTEGER, INTENT(in) ::   Kmm                  ! time-level index
      REAL(wp), DIMENSION(jpi,jpj,jpk) :: zdtdz, zdsdz, zdbdz      ! gradients in the pycnocline
 
@@ -1360,72 +1289,70 @@
      REAL(wp) :: zzeta_s=0.3, ztmp
 
-     DO jj = 2, jpjm1
-        DO ji = 2, jpim1
-           IF ( ibld(ji,jj) + ibld_ext < mbkt(ji,jj) ) THEN
-              IF ( lconv(ji,jj) ) THEN  ! convective conditions
-                    IF ( zdbdz_ext(ji,jj) > 0._wp .AND. &
-                         & (zdhdt(ji,jj) > 0._wp .AND. ln_osm_mle .AND. zdb_bl(ji,jj) > rn_osm_mle_thresh &
-                         &  .OR.  zdb_bl(ji,jj) > 0._wp)) THEN  ! zdhdt could be <0 due to FK, hence check zdhdt>0
+     DO_2D_00_00
+        IF ( ibld(ji,jj) + ibld_ext < mbkt(ji,jj) ) THEN
+           IF ( lconv(ji,jj) ) THEN  ! convective conditions
+                 IF ( zdbdz_ext(ji,jj) > 0._wp .AND. &
+                      & (zdhdt(ji,jj) > 0._wp .AND. ln_osm_mle .AND. zdb_bl(ji,jj) > rn_osm_mle_thresh &
+                      &  .OR.  zdb_bl(ji,jj) > 0._wp)) THEN  ! zdhdt could be <0 due to FK, hence check zdhdt>0
+                    ztmp = 1._wp/MAX(zdh(ji,jj), epsln)
+                    ztgrad = 0.5 * zdt_ml(ji,jj) * ztmp + zdtdz_ext(ji,jj)
+                    zsgrad = 0.5 * zds_ml(ji,jj) * ztmp + zdsdz_ext(ji,jj)
+                    zbgrad = 0.5 * zdb_ml(ji,jj) * ztmp + zdbdz_ext(ji,jj)
+                    zgamma_b_nd = zdbdz_ext(ji,jj) * zdh(ji,jj) / MAX(zdb_ml(ji,jj), epsln)
+                    zgamma_c = ( 3.14159 / 4.0 ) * ( 0.5 + zgamma_b_nd ) /&
+                         & ( 1.0 - 0.25 * SQRT( 3.14159 / 6.0 ) - 2.0 * zgamma_b_nd * zzeta_s )**2 ! check
+                    DO jk = 2, ibld(ji,jj)+ibld_ext
+                       znd = -( gdepw(ji,jj,jk, Kmm ) - zhbl(ji,jj) ) * ztmp
+                       IF ( znd <= zzeta_s ) THEN
+                          zdtdz(ji,jj,jk) = zdtdz_ext(ji,jj) + 0.5 * zdt_ml(ji,jj) * ztmp * &
+                               & EXP( -6.0 * ( znd -zzeta_s )**2 )
+                          zdsdz(ji,jj,jk) = zdsdz_ext(ji,jj) + 0.5 * zds_ml(ji,jj) * ztmp * &
+                               & EXP( -6.0 * ( znd -zzeta_s )**2 )
+                          zdbdz(ji,jj,jk) = zdbdz_ext(ji,jj) + 0.5 * zdb_ml(ji,jj) * ztmp * &
+                               & EXP( -6.0 * ( znd -zzeta_s )**2 )
+                       ELSE
+                          zdtdz(ji,jj,jk) =  ztgrad * EXP( -zgamma_c * ( znd - zzeta_s )**2 )
+                          zdsdz(ji,jj,jk) =  zsgrad * EXP( -zgamma_c * ( znd - zzeta_s )**2 )
+                          zdbdz(ji,jj,jk) =  zbgrad * EXP( -zgamma_c * ( znd - zzeta_s )**2 )
+                       ENDIF
+                    END DO
+                 ENDIF ! If condition not satisfied, no pycnocline present. Gradients have been initialised to zero, so do nothing
+           ELSE
+              ! stable conditions
+              ! if pycnocline profile only defined when depth steady of increasing.
+              IF ( zdhdt(ji,jj) >= 0.0 ) THEN        ! Depth increasing, or steady.
+                 IF ( zdb_bl(ji,jj) > 0._wp ) THEN
+                    IF ( zhol(ji,jj) >= 0.5 ) THEN      ! Very stable - 'thick' pycnocline
+                       ztmp = 1._wp/MAX(zhbl(ji,jj), epsln)
+                       ztgrad = zdt_bl(ji,jj) * ztmp
+                       zsgrad = zds_bl(ji,jj) * ztmp
+                       zbgrad = zdb_bl(ji,jj) * ztmp
+                       DO jk = 2, ibld(ji,jj)
+                          znd = gdepw(ji,jj,jk, Kmm ) * ztmp
+                          zdtdz(ji,jj,jk) =  ztgrad * EXP( -15.0 * ( znd - 0.9 )**2 )
+                          zdbdz(ji,jj,jk) =  zbgrad * EXP( -15.0 * ( znd - 0.9 )**2 )
+                          zdsdz(ji,jj,jk) =  zsgrad * EXP( -15.0 * ( znd - 0.9 )**2 )
+                       END DO
+                    ELSE                                   ! Slightly stable - 'thin' pycnoline - needed when stable layer begins to form.
                        ztmp = 1._wp/MAX(zdh(ji,jj), epsln)
-                       ztgrad = 0.5 * zdt_ml(ji,jj) * ztmp + zdtdz_ext(ji,jj)
-                       zsgrad = 0.5 * zds_ml(ji,jj) * ztmp + zdsdz_ext(ji,jj)
-                       zbgrad = 0.5 * zdb_ml(ji,jj) * ztmp + zdbdz_ext(ji,jj)
-                       zgamma_b_nd = zdbdz_ext(ji,jj) * zdh(ji,jj) / MAX(zdb_ml(ji,jj), epsln)
-                       zgamma_c = ( 3.14159 / 4.0 ) * ( 0.5 + zgamma_b_nd ) /&
-                            & ( 1.0 - 0.25 * SQRT( 3.14159 / 6.0 ) - 2.0 * zgamma_b_nd * zzeta_s )**2 ! check
-                       DO jk = 2, ibld(ji,jj)+ibld_ext
-                          znd = -( gdepw_n(ji,jj,jk) - zhbl(ji,jj) ) * ztmp
-                          IF ( znd <= zzeta_s ) THEN
-                             zdtdz(ji,jj,jk) = zdtdz_ext(ji,jj) + 0.5 * zdt_ml(ji,jj) * ztmp * &
-                                  & EXP( -6.0 * ( znd -zzeta_s )**2 )
-                             zdsdz(ji,jj,jk) = zdsdz_ext(ji,jj) + 0.5 * zds_ml(ji,jj) * ztmp * &
-                                  & EXP( -6.0 * ( znd -zzeta_s )**2 )
-                             zdbdz(ji,jj,jk) = zdbdz_ext(ji,jj) + 0.5 * zdb_ml(ji,jj) * ztmp * &
-                                  & EXP( -6.0 * ( znd -zzeta_s )**2 )
-                          ELSE
-                             zdtdz(ji,jj,jk) =  ztgrad * EXP( -zgamma_c * ( znd - zzeta_s )**2 )
-                             zdsdz(ji,jj,jk) =  zsgrad * EXP( -zgamma_c * ( znd - zzeta_s )**2 )
-                             zdbdz(ji,jj,jk) =  zbgrad * EXP( -zgamma_c * ( znd - zzeta_s )**2 )
-                          ENDIF
+                       ztgrad = zdt_bl(ji,jj) * ztmp
+                       zsgrad = zds_bl(ji,jj) * ztmp
+                       zbgrad = zdb_bl(ji,jj) * ztmp
+                       DO jk = 2, ibld(ji,jj)
+                          znd = -( gdepw(ji,jj,jk, Kmm ) - zhml(ji,jj) ) * ztmp
+                          zdtdz(ji,jj,jk) =  ztgrad * EXP( -1.75 * ( znd + 0.75 )**2 )
+                          zdbdz(ji,jj,jk) =  zbgrad * EXP( -1.75 * ( znd + 0.75 )**2 )
+                          zdsdz(ji,jj,jk) =  zsgrad * EXP( -1.75 * ( znd + 0.75 )**2 )
                        END DO
-                    ENDIF ! If condition not satisfied, no pycnocline present. Gradients have been initialised to zero, so do nothing
-              ELSE
-                 ! stable conditions
-                 ! if pycnocline profile only defined when depth steady of increasing.
-                 IF ( zdhdt(ji,jj) >= 0.0 ) THEN        ! Depth increasing, or steady.
-                    IF ( zdb_bl(ji,jj) > 0._wp ) THEN
-                       IF ( zhol(ji,jj) >= 0.5 ) THEN      ! Very stable - 'thick' pycnocline
-                          ztmp = 1._wp/MAX(zhbl(ji,jj), epsln)
-                          ztgrad = zdt_bl(ji,jj) * ztmp
-                          zsgrad = zds_bl(ji,jj) * ztmp
-                          zbgrad = zdb_bl(ji,jj) * ztmp
-                          DO jk = 2, ibld(ji,jj)
-                             znd = gdepw_n(ji,jj,jk) * ztmp
-                             zdtdz(ji,jj,jk) =  ztgrad * EXP( -15.0 * ( znd - 0.9 )**2 )
-                             zdbdz(ji,jj,jk) =  zbgrad * EXP( -15.0 * ( znd - 0.9 )**2 )
-                             zdsdz(ji,jj,jk) =  zsgrad * EXP( -15.0 * ( znd - 0.9 )**2 )
-                          END DO
-                       ELSE                                   ! Slightly stable - 'thin' pycnoline - needed when stable layer begins to form.
-                          ztmp = 1._wp/MAX(zdh(ji,jj), epsln)
-                          ztgrad = zdt_bl(ji,jj) * ztmp
-                          zsgrad = zds_bl(ji,jj) * ztmp
-                          zbgrad = zdb_bl(ji,jj) * ztmp
-                          DO jk = 2, ibld(ji,jj)
-                             znd = -( gdepw_n(ji,jj,jk) - zhml(ji,jj) ) * ztmp
-                             zdtdz(ji,jj,jk) =  ztgrad * EXP( -1.75 * ( znd + 0.75 )**2 )
-                             zdbdz(ji,jj,jk) =  zbgrad * EXP( -1.75 * ( znd + 0.75 )**2 )
-                             zdsdz(ji,jj,jk) =  zsgrad * EXP( -1.75 * ( znd + 0.75 )**2 )
-                          END DO
-                       ENDIF ! IF (zhol >=0.5)
-                    ENDIF    ! IF (zdb_bl> 0.)
-                 ENDIF       ! IF (zdhdt >= 0) zdhdt < 0 not considered since pycnocline profile is zero and profile arrays are intialized to zero
-              ENDIF          ! IF (lconv)
-           END IF      ! IF ( ibld(ji,jj) + ibld_ext < mbkt(ji,jj) )
-        END DO
-     END DO
+                    ENDIF ! IF (zhol >=0.5)
+                 ENDIF    ! IF (zdb_bl> 0.)
+              ENDIF       ! IF (zdhdt >= 0) zdhdt < 0 not considered since pycnocline profile is zero and profile arrays are intialized to zero
+           ENDIF          ! IF (lconv)
+        END IF      ! IF ( ibld(ji,jj) + ibld_ext < mbkt(ji,jj) )
+     END_2D
 
     END SUBROUTINE zdf_osm_pycnocline_scalar_profiles
 
-    SUBROUTINE zdf_osm_pycnocline_shear_profiles( zdudz, zdvdz )
+    SUBROUTINE zdf_osm_pycnocline_shear_profiles( zdudz, zdvdz, Kmm )
       !!---------------------------------------------------------------------
       !!                   ***  ROUTINE zdf_osm_pycnocline_shear_profiles  ***
@@ -1437,4 +1364,5 @@
       !!----------------------------------------------------------------------
 
+       INTEGER, INTENT(in) ::   Kmm                  ! time-level index
       REAL(wp), DIMENSION(jpi,jpj,jpk) :: zdudz, zdvdz
 
@@ -1443,46 +1371,44 @@
       REAL(wp) :: zzeta_v = 0.45
       !
-      DO jj = 2, jpjm1
-         DO ji = 2, jpim1
+      DO_2D_00_00
+         !
+         IF ( ibld(ji,jj) + ibld_ext < mbkt(ji,jj) ) THEN
+            IF ( lconv (ji,jj) ) THEN
+               ! Unstable conditions
+               zugrad = 0.7 * zdu_ml(ji,jj) / zdh(ji,jj) + 0.3 * zustar(ji,jj)*zustar(ji,jj) / &
+                    &      ( ( ( zvstr(ji,jj)**3 + 0.5 * zwstrc(ji,jj)**3 )**pthird * zhml(ji,jj) ) * &
+                    &      MIN(zla(ji,jj)**(8.0/3.0) + epsln, 0.12 ))
+               !Alan is this right?
+               zvgrad = ( 0.7 * zdv_ml(ji,jj) + &
+                    &    2.0 * ff_t(ji,jj) * zustke(ji,jj) * dstokes(ji,jj) / &
+                    &          ( ( zvstr(ji,jj)**3 + 0.5 * zwstrc(ji,jj)**3 )**pthird  + epsln ) &
+                    &      )/ (zdh(ji,jj)  + epsln )
+               DO jk = 2, ibld(ji,jj) - 1 + ibld_ext
+                  znd = -( gdepw(ji,jj,jk, Kmm ) - zhbl(ji,jj) ) / (zdh(ji,jj) + epsln ) - zzeta_v
+                  IF ( znd <= 0.0 ) THEN
+                     zdudz(ji,jj,jk) = 1.25 * zugrad * EXP( 3.0 * znd )
+                     zdvdz(ji,jj,jk) = 1.25 * zvgrad * EXP( 3.0 * znd )
+                  ELSE
+                     zdudz(ji,jj,jk) = 1.25 * zugrad * EXP( -2.0 * znd )
+                     zdvdz(ji,jj,jk) = 1.25 * zvgrad * EXP( -2.0 * znd )
+                  ENDIF
+               END DO
+            ELSE
+               ! stable conditions
+               zugrad = 3.25 * zdu_bl(ji,jj) / zhbl(ji,jj)
+               zvgrad = 2.75 * zdv_bl(ji,jj) / zhbl(ji,jj)
+               DO jk = 2, ibld(ji,jj)
+                  znd = gdepw(ji,jj,jk, Kmm ) / zhbl(ji,jj)
+                  IF ( znd < 1.0 ) THEN
+                     zdudz(ji,jj,jk) = zugrad * EXP( -40.0 * ( znd - 1.0 )**2 )
+                  ELSE
+                     zdudz(ji,jj,jk) = zugrad * EXP( -20.0 * ( znd - 1.0 )**2 )
+                  ENDIF
+                  zdvdz(ji,jj,jk) = zvgrad * EXP( -20.0 * ( znd - 0.85 )**2 )
+               END DO
+            ENDIF
             !
-            IF ( ibld(ji,jj) + ibld_ext < mbkt(ji,jj) ) THEN
-               IF ( lconv (ji,jj) ) THEN
-                  ! Unstable conditions
-                  zugrad = 0.7 * zdu_ml(ji,jj) / zdh(ji,jj) + 0.3 * zustar(ji,jj)*zustar(ji,jj) / &
-                       &      ( ( ( zvstr(ji,jj)**3 + 0.5 * zwstrc(ji,jj)**3 )**pthird * zhml(ji,jj) ) * &
-                       &      MIN(zla(ji,jj)**(8.0/3.0) + epsln, 0.12 ))
-                  !Alan is this right?
-                  zvgrad = ( 0.7 * zdv_ml(ji,jj) + &
-                       &    2.0 * ff_t(ji,jj) * zustke(ji,jj) * dstokes(ji,jj) / &
-                       &          ( ( zvstr(ji,jj)**3 + 0.5 * zwstrc(ji,jj)**3 )**pthird  + epsln ) &
-                       &      )/ (zdh(ji,jj)  + epsln )
-                  DO jk = 2, ibld(ji,jj) - 1 + ibld_ext
-                     znd = -( gdepw_n(ji,jj,jk) - zhbl(ji,jj) ) / (zdh(ji,jj) + epsln ) - zzeta_v
-                     IF ( znd <= 0.0 ) THEN
-                        zdudz(ji,jj,jk) = 1.25 * zugrad * EXP( 3.0 * znd )
-                        zdvdz(ji,jj,jk) = 1.25 * zvgrad * EXP( 3.0 * znd )
-                     ELSE
-                        zdudz(ji,jj,jk) = 1.25 * zugrad * EXP( -2.0 * znd )
-                        zdvdz(ji,jj,jk) = 1.25 * zvgrad * EXP( -2.0 * znd )
-                     ENDIF
-                  END DO
-               ELSE
-                  ! stable conditions
-                  zugrad = 3.25 * zdu_bl(ji,jj) / zhbl(ji,jj)
-                  zvgrad = 2.75 * zdv_bl(ji,jj) / zhbl(ji,jj)
-                  DO jk = 2, ibld(ji,jj)
-                     znd = gdepw_n(ji,jj,jk) / zhbl(ji,jj)
-                     IF ( znd < 1.0 ) THEN
-                        zdudz(ji,jj,jk) = zugrad * EXP( -40.0 * ( znd - 1.0 )**2 )
-                     ELSE
-                        zdudz(ji,jj,jk) = zugrad * EXP( -20.0 * ( znd - 1.0 )**2 )
-                     ENDIF
-                     zdvdz(ji,jj,jk) = zvgrad * EXP( -20.0 * ( znd - 0.85 )**2 )
-                  END DO
-               ENDIF
-               !
-            END IF      ! IF ( ibld(ji,jj) + ibld_ext < mbkt(ji,jj) )
-         END DO
-      END DO
+         END IF      ! IF ( ibld(ji,jj) + ibld_ext < mbkt(ji,jj) )
+      END_2D
     END SUBROUTINE zdf_osm_pycnocline_shear_profiles
 
